uses World;
var myworld : TWorld;
	port : longint;
	e, j : integer;
	alpha : real = 0.0;
  {monstr:array[0..5,0..5] of integer;}
  grad,max,arc,arcM:single;
  i,k:integer;
  x0,y0:single;
  arcMonster:array[0..40000] of integer;

  count,countM:integer;
  minM,minI:integer;
  flN:integer;
  strat:integer;
  matX,matY,dispX,dispY,disp:single;
  r1,r2,r3:single;
  k1,k2,k3:single;
  x_n,y_n:single;
  stenk,beg:single;
  minJ:integer;
  minRas:extended;
begin
	{Check for enough parameters}
	if ParamCount < 2 then
    begin
		writeln('Parameters : ip port');
		halt(10);
	end;

	{Get port number}
	Val(ParamStr(2), port, e);

	if (e <> 0) then
	begin
		writeln('Wrong port number!');
		halt(10);
	end;

	{Establish connection with the server}
	Open(ParamStr(1), port);
   strat:=0;
	{Infinite loop}
	while (true) do
	begin
		{Send our turn and receive the update of the game world}
		makeMove(myworld);
	 //	writeln('Frame ', myworld.player.Time, ' HP: ', myworld.player.HitPoints:0:3, ' x: ', myworld.player.PositionX:0:3, ' y: ', myworld.player.PositionY:0:3);
   x0:=myworld.player.PositionX;
   y0:=myworld.player.PositionY;

   if(strat=0) then begin
   max:=0;
    for  j := 1 to MAXMONSTERS do
			if (myworld.monsters[j].ClassName > 0) then
          if(myworld.monsters[j].MaxVelocity>max) then max:=myworld.monsters[j].MaxVelocity;

    if (myworld.player.MaxVelocity<>0) then
      arc:=arctan(max/myworld.player.MaxVelocity)
    else
       arc:=1;
    if(arc<0.01) then arc:=0.1;
    if(2*Pi/arc>30) then arc:=2*Pi/29;
     count:=round(2*Pi/arc);
    for i:=1 to count do
      arcMonster[i]:=0;

    for  j := 1 to MAXMONSTERS do begin
    if myworld.monsters[j].PositionY-y0<0.001 then begin
         if (myworld.monsters[j].PositionX-x0>0)then arcMonster[round(0/arc)]:=arcMonster[round(0/arc)]+1;
         if (myworld.monsters[j].PositionX-x0<0)then arcMonster[round(pi/arc)]:=arcMonster[round(pi/arc)]+1;
          continue;
    end;

    arcM:=arctan(myworld.monsters[j].PositionX-x0)/(myworld.monsters[j].PositionY-y0);
    if((myworld.monsters[j].PositionX-x0<0)and(myworld.monsters[j].PositionY-y0>0)) then arcM:=arcM+Pi;
    if((myworld.monsters[j].PositionX-x0<0)and(myworld.monsters[j].PositionY-y0<0)) then arcM:=arcM+Pi;
    if((myworld.monsters[j].PositionX-x0>0)and(myworld.monsters[j].PositionY-y0<0)) then arcM:=arcM+2*Pi;
      arcMonster[round(arcM/arc)]:=arcMonster[round(arcM/arc)]+1;
    end;

    minM:=1000;
    for i := 0 to count do
      if(arcMonster[i]<minM) then begin minM:=arcMonster[i]; minI:=i;end;
      writeln(arc,' ',minI);
    run(myworld, cos(minI*arc),sin(minI*arc));
    // run(myworld, 0.1,0.1);

 		alpha := alpha +  0.02;
  flN:=0;
   { for  j := 1 to MAXMONSTERS do
			if ((myworld.monsters[j].ClassName>0)) then
			begin
      arcM:=arctan(myworld.monsters[j].PositionX-x0)/(myworld.monsters[j].PositionY-y0);
    if((myworld.monsters[j].PositionX-x0<0)and(myworld.monsters[j].PositionY-y0>0)) then arcM:=arcM+Pi;
    if((myworld.monsters[j].PositionX-x0<0)and(myworld.monsters[j].PositionY-y0<0)) then arcM:=arcM+Pi;
    if((myworld.monsters[j].PositionX-x0>0)and(myworld.monsters[j].PositionY-y0<0)) then arcM:=arcM+2*Pi;
    if (round(arcM/arc)=minI) then begin
      shoot(myworld, myworld.monsters[j].PositionX - myworld.player.PositionX, myworld.monsters[j].PositionY - myworld.player.PositionY);
      fln:=1;
      break;
    end;
    end;
    if fln=0 then
    strat:=1;
     for  j := 1 to MAXMONSTERS do
      	if ((myworld.monsters[j].ClassName>0)) then begin
        shoot(myworld, myworld.monsters[j].PositionX - myworld.player.PositionX, myworld.monsters[j].PositionY - myworld.player.PositionY);
         break;
        end;    }
           for  j := 1 to MAXMONSTERS do
      	if ((myworld.monsters[j].ClassName>0)) then begin
          if minRas>sqrt(sqr(myworld.monsters[j].PositionX-x0)+sqr(myworld.monsters[j].PositionY-y0)) then begin
            minRas:=sqrt(sqr(myworld.monsters[j].PositionX-x0)+sqr(myworld.monsters[j].PositionY-y0));
            minJ:=j;
          end;
        end;
        shoot(myworld, myworld.monsters[minJ].PositionX - myworld.player.PositionX, myworld.monsters[minJ].PositionY - myworld.player.PositionY);
   end;


if(strat=1) then begin
countM:=0;
matX:=0;
matY:=0;
dispX:=0;
dispY:=0;
 for  j := 1 to MAXMONSTERS do
      	if ((myworld.monsters[j].ClassName>0)) then begin
        inc(countM);
        matX:=matX+myworld.monsters[j].PositionX;
        matY:=matY+myworld.monsters[j].PositionY;
        end;
 matX:=matX/countM;
 matY:=matY/countM;
  for  j := 1 to MAXMONSTERS do
      	if ((myworld.monsters[j].ClassName>0)) then begin
        dispX:=dispX+sqr(matX-myworld.monsters[j].PositionX);
        dispY:=dispY+sqr(matY-myworld.monsters[j].PositionY);
        end;
 dispX:=sqrt(dispX/countM);
 dispY:=sqrt(dispY/countM);
 r1:=sqrt(sqr(x0-matX)+sqr(y0-matY));
 disp:=r1+sqrt(sqr(dispX)+sqr(dispY));

 if(x0>0.5) then
  r2:=(0.5-x0)
 else
  r2:=(0.5-x0);
 if(y0>0.5) then
  r3:=0.5-y0
 else
  r3:=0.5-y0;
  beg:=(1-sqrt(sqr(x0-matX)+sqr(y0-matY))*4;
  stenk:=4;
  x_n:=beg*(x0-matX)/sqrt(sqr(x0-matX)+sqr(y0-matY))+stenk*r2;
  y_n:=beg*(y0-matY)/sqrt(sqr(x0-matX)+sqr(y0-matY))+stenk*r3;
  writeln('sdfsdfsdfdsf');
  run(myworld, x_n,y_n);
    minRas:=200;
   for  j := 1 to MAXMONSTERS do
      	if ((myworld.monsters[j].ClassName>0)) then begin
          if minRas>sqrt(sqr(myworld.monsters[j].PositionX-x0)+sqr(myworld.monsters[j].PositionY-y0)) then begin
            minRas:=sqrt(sqr(myworld.monsters[j].PositionX-x0)+sqr(myworld.monsters[j].PositionY-y0));
            minJ:=j;
          end;
        end;
        shoot(myworld, myworld.monsters[minJ].PositionX - myworld.player.PositionX, myworld.monsters[minJ].PositionY - myworld.player.PositionY);
   if sqrt(sqr(x0-matX)+sqr(y0-matY))<0.2 then strat:=0;
end;
  {for i := 0 to 5 do
     for k := 0 to 5 do
      monstr[i,k]:=0;
		for  j := 1 to MAXMONSTERS do
			if (myworld.monsters[j].ClassName > 0) then
			begin
        inc(monstr[trunc(myworld.monsters[j].PositionX*5),trunc(myworld.monsters[j].PositionY*5)]);
      end;   }


   { for i := 0 to 5 do begin
     for k := 0 to 5 do
      write(' - ',monstr[i,k]);
     writeln;
    end;
     writeln;
     writeln; }
end;

end.