unit socketWrapper;

interface 

procedure connectServer(ip : PChar; port : longint); cdecl;
function nextInt() : longint; cdecl;
function nextFloat() : single; cdecl;
procedure writeInt(value : longint); cdecl;
procedure writeFloat(value : single); cdecl;
procedure lockMutex(); cdecl;
procedure unlockMutex(); cdecl;
procedure flush(); cdecl;
procedure closeSocket(); cdecl;

implementation
  
procedure connectServer(ip : PChar; port : longint); cdecl; external 'libsocket';
function nextInt() : longint; cdecl; external 'libsocket';
function nextFloat() : single; cdecl; external 'libsocket';
procedure writeInt(value : longint); cdecl; external 'libsocket';
procedure writeFloat(value : single); cdecl; external 'libsocket';
procedure lockMutex(); cdecl; external 'libsocket';
procedure unlockMutex(); cdecl; external 'libsocket';
procedure flush(); cdecl; external 'libsocket';
procedure closeSocket(); cdecl; external 'libsocket';

end.
