unit socketWrapper;

interface 

procedure connectServer(ip : PChar; port : integer); cdecl;
function nextInt() : integer; cdecl;
function nextFloat() : single; cdecl;
procedure writeInt(value : integer); cdecl;
procedure writeFloat(value : single); cdecl;
procedure lockMutex(); cdecl;
procedure unlockMutex(); cdecl;
procedure flush(); cdecl;
procedure closeSocket(); cdecl;

implementation
  
procedure connectServer; external 'libsocket.dll';
function nextInt; external 'libsocket.dll';
function nextFloat; external 'libsocket.dll';
procedure writeInt; external 'libsocket.dll';
procedure writeFloat; external 'libsocket.dll';
procedure lockMutex; external 'libsocket.dll';
procedure unlockMutex; external 'libsocket.dll';
procedure flush; external 'libsocket.dll';
procedure closeSocket; external 'libsocket.dll';

end.
