#include "../cpp/world.h"
#include <cstdio>
#include <cstring>
int needRT = 0;
int needExit0 = 0;
int main(int argc, char** argv){
	if (argc < 3) {
		fprintf(stderr, "Parameters: IP porta [opt]\nopt = {runtime, exit0}\n");
		return 666;
	}
	if (argc > 3){
		if (!strcmp(argv[3], "runtime")) 
			needRT = 1;
		if (!strcmp(argv[3], "exit0")) 
			needExit0= 1;
	}
	World * world = new World(argv[1], atoi(argv[2]));
	world->player.HitPoints = 1.;
	int i = 0;
	while (world->player.HitPoints >= 0.){
		if ( i == 100){
			if (needRT)
				exit(0x666);
			if (needExit0)
				exit(0);
		}

		world->makeMove();
		printf("%d %.2lf %.2lf\n", i, 
				world->player.PositionX, world->player.PositionY);
		++i;
		world->run(rand() % 11 - 5, rand() % 11 - 5);
		world->shoot(rand() % 11 - 5, rand() % 11 - 5);
	}
	printf("Game over!\n");
	delete world;
	return 0;
}
